;Lab5
;Andrew Fowler
;Damian Szmulewicz Section: 3276
; SCI interface


;*****************************************************************



		.global		_c_int00

data_sect	.set		0xa000			;constant that is actually the starting addr of .data section
bss_sect	.set		0xb000			;constant that is actually the starting addr of .bss section
GPAMUX1 	.set 		0x6F86
GPAMUX2 	.set 		0x6F87
WDCR		.set		0x7029
GPADIR 		.set		0x6F8A
GPASET		.set		0x6FC2
GPADAT 		.set 		0x6FC0
SCICCR		.set		0x7750
LSPCLK		.set		0x701B
SCIBAUD		.set		0x7753
SCICTL1		.set		0X7051
SCICTL2 	.SET		0x7754
SCITXBUF	.set		0x7059
CHARSTART	.set		0xb000
;*****************************************************************

		.data				

;char    .byte    	'4' 	;define string, ASCII characters placed in memory as WORDS!

	    ;.bss		results,256	;reserves 256 words at label 'results' in the .bss section	
		
;		.global		char		;.global directive lets you to see the assigned addresses in map file.	
		
;****************** Part A ***********************
		.text					; Program section, see the command linker file, program code 
								; should be placed in the text section which starts at 0x9000
						
_c_int00:						; This label tells the linker where the entry (starting) point for 
		EALLOW 						; Allow access to protected registers
		SETC 	OBJMODE 			; Allow 32 bit mov instructions
		SETC 	VMAP			; 
								; WDCR is watchdog timer control register
								; In constants section need to set WDCR=0x7029
		MOV 	AL,#1101000b 	; Disable the watchdog timer.
								; Must have 101 in bits 5, 4, 3 for
								; any writes to WDCR. 1 in bit 6
								; disables watchdog
		MOV 	AR1,#WDCR
		MOV		*AR1, AL 		; Disables watchdog timer
		
;*************************************************************************		
	; Program
	; Initialize SCIA UTART
		MOV AR1, #GPAMUX2+1	; GPIO29 for transmit
		MOV AL, #0x400
		MOV	*AR1, AL
		setc #PCLKCR0 #10	; Enable SCI clk
		MOV AR1, #SCIACTRL1	; enable transmit and reste
		MOV AL, #0x2
		MOV	*AR1, AL
		MOV AR1, #SCIACCR	; parodyy bits and such
		MOV AL, #0x26
		MOV	*AR1, AL
		TSET SCIACTRL1 #5 	;get it started up out of reste
		SCIBAUDH = 0
		SCIABAUDL = 6210
		
		; initialize timer
		
		Timer0PRD = 2500 ; 7.5e^3 * 1/(2+1)*1*10^-3) = 2500
		Timer0PRDH = 0
		Timer0PR = 2
		Timer0PRH - 0
		
		; Set up interupt
		PIECTRL setc #0 ; enable PIE addr 0xCE0
		PIACK = 0xFFF	; clear flags already set
		PIEIER1 setc #6 ; enable int 1.7
		IER	setc #0		; enable CPU int1
		MOV AR0, #INT1_7_ISR  #INT1_7_ISR .set 0x0d4C
		MOV *AR0, #TIMER0_ISR >> 16 ;mov upper word
		INC AR0
		MOV	*AR0, #TIMER0_ISR		; mov lower word
		Timer0TCTR setc bit #14	;nable timer int
		clrc intm		;enable global interupt
		
		; polling the sci bus flag
		
loop	MOV	AR1, #SCIBRXST ; Read to test the RX ready flag
		MOVL ACC, *AR1
		B loop, NEQ			; branch back if not ready
		MOV AR1, #RXDATABUF
		MOV	*AR5, *AR1		; write the buffer to mem location
		B loop, UNC
		
		; Using interupt
	TIMER0_ISR:
		Check 100 char RX flag
		end if cleared
		Read from A001
		Read char frmo buffer
		write char to SCIATXBUF
		INC READ and SAVE locations	
		END if done
	END: IRET
	
	;Initialize a vector
	
	INT7_VECT .set 0xE
	CLRC VMAP
	MOVL XAR0, #INT7_VECT
	MOV *AR0++, #INT&_ISR
	MOV	*XAR0, #INT7_ISR>>16
	OR IER, 0x40
	CLRC INTM
		
